﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Windows;
using System.Threading;
using System.Windows.Threading;

namespace WpfApplication1
{
    /// <summary>
    /// Lógica de interacción para App.xaml
    /// </summary>
    public partial class App : Application
    {
        protected override void OnStartup(StartupEventArgs e)
        {
            base.OnStartup(e);

            //---------------------------------------------------------------------------------------------------------------
            //Create a second UI Thread (this thread will be locked (suspended) by the main thread)
            Thread myThread = new Thread(() =>
            {
                //Open a window in this thread
                SecondWindow secondWindow = new SecondWindow();
                secondWindow.Title = "Second UI Thread's Window";
                secondWindow.DataContext = new SecondWindowViewModel();
                secondWindow.Show();

                //Run the dispatcher
                System.Windows.Threading.Dispatcher.Run();
            });
            myThread.SetApartmentState(ApartmentState.STA);
            myThread.IsBackground = true;
            myThread.Start();

            //---------------------------------------------------------------------------------------------------------------
            //Open the main thread's main window
            MainWindow mainWindow = new MainWindow();
            mainWindow.Title = "This is the Main thread's Main Window";
            mainWindow.DataContext = new MainWindowViewModel();
            mainWindow.Show();
        }
    }
}
