﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Lógica de interacción para MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void mDocumentContentHost_ClosingViewModel(object sender, Infragistics.Windows.Extensions.ClosingViewModelEventArgs e)
        {
            if (e.ClosingItem != null)
            {
                CloosableViewModel cvm = e.ClosingItem as CloosableViewModel;
                if (cvm != null)
                {
                    cvm.BeforeCloseCommand.Execute(null);

                    e.Cancel = cvm.CancelClosingOperation;

                    //Mikel: si la operación de cerrado se ha cancelado no se ejecuta el codigo siguiente por que la ventana se cerraría
                    //Si no libera bien memoria hay queejecutar el código cuando la ventana se cierre realmente.
                    if (!e.Cancel)
                    {
                        //dvillaba - MUCHO OJO!!!
                        //Las siguientes lineas son para gestionar el correcto liberado de memoria por
                        //parte del objeto "DocumentContentHost". Este se estaba quedando con instancias de ViewModels
                        // que deberian destruirse debido al parche que es el objeto "igExtensions:ContentPaneFactory",
                        //ya que este parche no gestiona bien la liberacion de memoria cuando se cierran splitpanes-

                        //dvillaba - Actualización, con la version 11.1 del control parece que se corrige el error,
                        //pero porsi lo vuelvio a ver, no me voy a deshacer del código que lo solucionaba

                        //foreach (SplitPane vSplitPane in mDocumentContentHost.Panes)
                        //{
                        //    foreach (TabGroupPane vTabGroupPane in vSplitPane.Panes)
                        //    {
                        //        ContentPane vContentPaneARemover = null;
                        //        foreach (ContentPane vContentPane in vTabGroupPane.Items)
                        //        {
                        //            if (vContentPane.Content == cvm)
                        //                vContentPaneARemover = vContentPane;
                        //        }
                        //        if (vContentPaneARemover != null)
                        //        {
                        //            if (vTabGroupPane.SelectedItem == vContentPaneARemover)
                        //                vTabGroupPane.SelectedItem = null;
                        //            vTabGroupPane.Items.Remove(vContentPaneARemover);
                        //        }
                        //    }
                        //}
                    }
                }
            }
        }
    }
}
